require 'minitest_helper'

describe StockPriceImitation::Generator do
  describe '#initialize' do
    it 'new instance' do
      generator = StockPriceImitation::Generator
      tick_count = 10

      assert generator.new(tick_count).class == generator
    end
  end

  describe '#execute' do
    before do
      @tick_count = 100
      @first_price = 1000

      @generator = StockPriceImitation::Generator.new(@tick_count, @first_price)
      @price_movement = @generator.execute
    end

    it 'is a Array' do
      assert @price_movement.is_a? Array
    end

    it 'length is tick_count' do
      assert @price_movement.size == @tick_count
    end

    it 'a tick is a Float' do
      @price_movement.each do |tick|
        assert tick.is_a? Numeric
      end
    end

    it 'price is not negative number' do
      generator = StockPriceImitation::Generator.new(1000, 10)
      price_movement = generator.execute

      price_movement.each do |price|
        assert price >= 0
      end
    end
  end
end
